

import asiel
import sys


class Echo(asiel.RawProtocol):
    def connectionEstablished(self):
        print "Client connected: %s:%s"%self.addr

    def dataReceived(self, data):
        # close if receives a blank line
        if not data.strip():
            self.close()
            return

        self.send(data)

    def connectionLost(self):
        print "Client disconnected: %s:%s"%self.addr


try:
    port = int(sys.argv[1])
except (ValueError, IndexError):
    port = 8001


server = asiel.TCPServer()
server.bind(port, Echo)
print "Running on host/port: %s:%s with %s protocol."%(server.host, port, Echo.__name__)
try:
    server.run()
except KeyboardInterrupt:
    server.stop()
    server.clean()
